=== modified file 'revisionview.py'
--- revisionview.py	2007-12-06 17:24:46 +0000
+++ revisionview.py	2007-12-06 23:01:28 +0000
@@ -66,9 +66,9 @@
         self.set_current_page(0)
         
         self._show_callback = None
-        self._go_callback = None
         self._clicked_callback = None
 
+        self._revision = None
         self._branch = branch
 
         if self._branch.supports_tags():
@@ -101,9 +101,6 @@
     def set_show_callback(self, callback):
         self._show_callback = callback
 
-    def set_go_callback(self, callback):
-        self._go_callback = callback
-
     def set_file_id(self, file_id):
         """Set a specific file id that we want to track.
 
@@ -113,7 +110,11 @@
         self.set_property('file-id', file_id)
 
     def set_revision(self, revision, children=[]):
-        self.set_property('revision', revision)
+        if revision != self._revision:
+            self.set_property('revision', revision)
+
+    def get_revision(self):
+        return self.get_property('revision')
 
     def _set_revision(self, revision, children=[]):
         if revision is None: return
@@ -180,7 +181,6 @@
 
     def _go_clicked_cb(self, widget, revid):
         """Callback for when the go button for a parent is clicked."""
-        self._go_callback(revid)
 
     def _add_tags(self, *args):
         if self._tagdict.has_key(self._revision.revision_id):
@@ -237,11 +237,9 @@
                 hbox.pack_start(button, expand=False, fill=True)
                 button.show()
 
-            if self._go_callback is not None:
-                button = gtk.Button(revid)
-                button.connect("clicked", self._go_clicked_cb, revid)
-            else:
-                button = gtk.Label(revid)
+            button = gtk.Button(revid)
+            button.connect("clicked",
+                    lambda w, r: self.set_revision(self._branch.repository.get_revision(revid)), revid)
             button.set_use_underline(False)
             hbox.pack_start(button, expand=False, fill=True)
             button.show()

=== modified file 'viz/branchwin.py'
--- viz/branchwin.py	2007-12-02 16:28:38 +0000
+++ viz/branchwin.py	2007-12-06 23:01:28 +0000
@@ -296,7 +296,7 @@
         self.revisionview.set_size_request(width, int(height / 2.5))
         self.revisionview.show()
         self.revisionview.set_show_callback(self._show_clicked_cb)
-        self.revisionview.set_go_callback(self._go_clicked_cb)
+        self.revisionview.connect('notify::revision', self._go_clicked_cb)
         return self.revisionview
 
     def _tag_selected_cb(self, menuitem, revid):
@@ -359,9 +359,10 @@
         """Callback for when the forward button is clicked."""
         self.treeview.forward()
 
-    def _go_clicked_cb(self, revid):
+    def _go_clicked_cb(self, w, p):
         """Callback for when the go button for a parent is clicked."""
-        self.treeview.set_revision_id(revid)
+        if self.revisionview.get_revision() is not None:
+            self.treeview.set_revision(self.revisionview.get_revision())
 
     def _show_clicked_cb(self, revid, parentid):
         """Callback for when the show button for a parent is clicked."""

